/*
 * This part of podic-0.1 is licensed under GPL.
 */

#include <sys/fcntl.h>
#include <sys/types.h>
#include <sys/socket.h>
#include <netinet/in.h>
#include <netdb.h>
#include <stdio.h>

#define BUFLEN (128)

int main(argc, argv)
int argc;
char **argv;
{
	int s;
	char ch, command[BUFLEN];
	struct hostent *servhost;
	struct sockaddr_in server;
	struct servent *service;

	if (argc == 2){ 
		show_help();
		if (strncmp(argv[1], "-h", strlen("-h")) == 0 ||
		    strncmp(argv[1], "--help", strlen("--help")) == 0){
			exit(0);
		}else{
			exit(1);
		}
	}else{
		if (argc == 4){ 
			/* do nothing */;
		}else{
			show_help();
			exit(1);
		}
	}

	if ((servhost = gethostbyname("localhost")) == NULL){
		fprintf(stderr, "gethostbyname error\n");
		exit(1);
	}
	bzero(&server, sizeof(server));
	server.sin_family = AF_INET;
	bcopy(servhost->h_addr, &server.sin_addr, servhost->h_length);
	server.sin_port = htons(1178);
	if ((s = socket(AF_INET, SOCK_STREAM, 0)) < 0){
		fprintf(stderr, "socket error\n");
		exit(1);
	}
	if ((connect(s, (struct sockaddr *)&server, sizeof(server))) < 0){
		fprintf(stderr, "connect error\n");
		exit(1);
	}

	if ((1 + strlen(argv[2]) + 1 + strlen(argv[3]) + 1 + 1) < BUFLEN){
		if (strncmp(argv[1], "-r", strlen("-r")) == 0){
			sprintf(command, "5%-s %-s\n", argv[2], argv[3]);
		}else if (strncmp(argv[1], "-d", strlen("-d")) == 0){
			sprintf(command, "6%-s %-s\n", argv[2], argv[3]);
		}else{
			fprintf(stderr, "option error\n");
			exit(1);
		}
	}else{
		fprintf(stderr, "TANGO, YOMI too long error\n");
		exit(1);
	}
	write(s, command, strlen(command));
	read(s, &ch, 1);

	sprintf(command, "0\n");
	write(s, command, strlen(command));

	shutdown(s, 2);
	close(s);
}

int show_help()
{
	fprintf(stderr, "Usage : podic -r TANGO YOMI\n");
	fprintf(stderr, "        podic -d TANGO YOMI\n");
	fprintf(stderr, "  -r for regist\n");
	fprintf(stderr, "  -d for unregist\n");
	return 0;
}
